﻿package 
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	public class Main extends MovieClip
	{
		private var urlRequest:URLRequest;
		private var urlLoader:URLLoader;
		private var xml:XML;
		private var myMc:boxMc;
		private var myBlueMc:blue_mc;
		private var myOrange:orange;
		private var myRing:joint;
		//private var mc:thumMc;
		private var arr:Array = [mc0,mc1,mc2,mc3,mc4,mc5];
		public function Main():void
		{
			urlRequest = new URLRequest("image.xml");
			urlLoader = new URLLoader();
			urlLoader.load(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE,urlLoaded);
			blueMc.buttonMode = true;
			blueMc.addEventListener(MouseEvent.CLICK,add);
			blueLine.buttonMode = true;
			blueLine.addEventListener(MouseEvent.CLICK,remove);
			orangeRoll.buttonMode = true;
			orangeRoll.addEventListener(MouseEvent.CLICK,add);
			orangeLine.buttonMode = true;
			orangeLine.addEventListener(MouseEvent.CLICK,remove);
			ring.buttonMode = true;
			ring.addEventListener(MouseEvent.CLICK,add);
			ringLine.buttonMode = true;
			ringLine.addEventListener(MouseEvent.CLICK,remove);
			reset_btn.addEventListener(MouseEvent.CLICK,resetFunc);
			mc.visible = false;
			/*mc = new thumMc();
			addChild(mc);*/
		}

		private function urlLoaded(event:Event):void
		{
			xml = XML(event.target.data);
			/* for(var i=0;i<=3;i++)
			 {
			   myMc = new boxMc();
			   myMc.x = xml.image[i].@x;
			   myMc.y = xml.image[i].@y;
			   myMc.name = "mc"+i;
			   addChild(myMc);
			   myMc.addEventListener(MouseEvent.CLICK,go);
			   
			 }*/
			for (var i=0; i<arr.length; i++)
			{
				this["mc" + i].buttonMode = true;
				this["mc" + i].addEventListener(MouseEvent.CLICK,assign);
			}
		}
		private function assign(e:MouseEvent):void
		{
			var str:String = e.currentTarget.name;
			var num:String = str.substr(2,1);
			var blueNum:Number=blueLine.numChildren;
			var orangeNum:Number=orangeLine.numChildren;
			var ringNum:Number=ringLine.numChildren;
			if (blueLine.numChildren != 0)
			{
				for (var i=1; i<=blueNum; i++)
				{
					blueLine.removeChildAt(blueLine.numChildren-1);
				}
			}
			if (orangeLine.numChildren != 0)
			{
				for (var j=1; j<=orangeNum; j++)
				{
					orangeLine.removeChildAt(orangeLine.numChildren-1);
				}
			}
			if (ringLine.numChildren != 0)
			{
				for (var k=1; k<=ringNum; k++)
				{
					ringLine.removeChildAt(ringLine.numChildren-1);
				}
			}
			loadImage(xml.image[str.substr(2,1)].@name,Number(num));
		}
		private function go(e:MouseEvent)
		{
			var str:String = e.currentTarget.name;

			// loadImage(xml.image[str.substr(2,1)].@name);

		}
		private function resetFunc(obj:MouseEvent){
			var blueNum:Number=blueLine.numChildren;
			var orangeNum:Number=orangeLine.numChildren;
			var ringNum:Number=ringLine.numChildren;
			if (blueLine.numChildren != 0)
			{
				for (var i=1; i<=blueNum; i++)
				{
					blueLine.removeChildAt(blueLine.numChildren-1);
				}
			}
			if (orangeLine.numChildren != 0)
			{
				for (var j=1; j<=orangeNum; j++)
				{
					orangeLine.removeChildAt(orangeLine.numChildren-1);
				}
			}
			if (ringLine.numChildren != 0)
			{
				for (var k=1; k<=ringNum; k++)
				{
					ringLine.removeChildAt(ringLine.numChildren-1);
				}
			}
			mc.visible = false;
			if (mc.numChildren != 0)
			{
				//mc.removeChildAt(0);
			}
		}
		private function loadImage(path:String,num:Number)
		{
			var pictLdr:Loader = new Loader();
			var pictURLReq:URLRequest = new URLRequest(path);
			pictLdr.load(pictURLReq);
			mc.x = xml.image[num]. @ x;
			mc.y = xml.image[num]. @ y;
			mc.addChild(pictLdr);
			mc.visible = true;
			blueLine.x = xml.image[num]. @ bX;
			orangeLine.x = xml.image[num]. @ bX;
			ringLine.x = xml.image[num]. @ bX;
			if (mc.numChildren != 0)
			{
				mc.removeChildAt(0);
			}
		}

		private function add(e:MouseEvent):void
		{
			if (mc.getChildAt(0) is Shape == false)
			{
				if (e.currentTarget.name == "blueMc")
				{
					myBlueMc = new blue_mc();
					if (blueLine.numChildren != 0)
					{
						//myBlueMc.x = blueLine.width - 15;
						//myBlueMc.x = blueLine.width-1;
						myBlueMc.x = blueLine.width-1;
					}
					blueLine.addChild(myBlueMc);
				}
				else if (e.currentTarget.name == "orangeRoll")
				{
					myOrange = new orange();
					if (orangeLine.numChildren != 0)
					{
						//myOrange.x = orangeLine.width-3;
						myOrange.x = orangeLine.width;
					}
					orangeLine.addChild(myOrange);
				}
				else
				{
					myRing = new joint();
					if (ringLine.numChildren != 0)
					{
						//myRing.x = ringLine.width-8;
						myRing.x = ringLine.width;
					}
					ringLine.addChild(myRing);
				}
			}
		}
		private function remove(e:MouseEvent)
		{
			if (e.currentTarget.name == "blueLine")
			{
				if (blueLine.numChildren != 0)
				{
					//myBlueMc.x = blueLine.width-15;  
					blueLine.removeChildAt(blueLine.numChildren-1);
				}
			}
			else if (e.currentTarget.name == "orangeLine")
			{
				if (orangeLine.numChildren != 0)
				{
					//myBlueMc.x = blueLine.width-15;  
					orangeLine.removeChildAt(orangeLine.numChildren-1);
				}
			}
			else
			{
				if (ringLine.numChildren != 0)
				{
					//myBlueMc.x = blueLine.width-15;  
					ringLine.removeChildAt(ringLine.numChildren-1);
				}
			}
		}
	}
}