﻿package com{
	
	import flash.display.MovieClip;
	import flash.geom.Rectangle;
	import flash.utils.getDefinitionByName;
	import flash.events.MouseEvent;
	import flash.display.Stage;
	
	public class moneyFreePlay extends MovieClip{

		private var moneyArr:Array = ["money_0.05_t", "money_0.10_t", "money_0.20_t", "money_0.50_t", "money_1_t", "money_2_t",  "money_0.05_h", "money_0.10_h", "money_0.20_h", "money_0.50_h", "money_1_h", "money_2_h"];
		private var money_mc:MovieClip;
		private var moneyCnt:Number = 0;
		private var prevClip:MovieClip;
		private var currentClip:MovieClip;
		private var totMoney:Number = 0;
		private var counter:Number = 0;
		private var moveClip:MovieClip;
		
		//adds money to stage
		public function moneyFreePlay():void{
			var xPos:Number = 180;
			var yPos:Number = 370;
			var clipWidth:Number;
			var clipHeight:Number;
			var cnt:Number = 0;
			var maxHeight:Number = 0;
			for(var i:Number = 0; i < moneyArr.length; i++){
				var clipClass:Class = getDefinitionByName(moneyArr[i]) as Class;
				var clip:MovieClip = new clipClass();
				addChild(clip);
				clip.name = moneyArr[i];
				cnt++;
				clip.x = xPos;
				clip.y = yPos;
				if ( maxHeight < clip.height ) {
					maxHeight = clip.height;
				}
				if ( i == 5 ) {
					xPos = 180;
					yPos += maxHeight + 15;					
				} else {
					xPos += clip.width + 15;
				}
				clip.addEventListener(MouseEvent.MOUSE_DOWN, fnAttachMoney);
			}
			money_mc = new MovieClip;
			addChild(money_mc);
			display_mc.visible = false;
			display_mc.dispTxt.text = "$0.00";
			hideShowTotal_btn.hideTotTxt_mc.visible = false;
			delete_btn.addEventListener(MouseEvent.MOUSE_DOWN, fnDeleteSelected);
			hideShowTotal_btn.addEventListener(MouseEvent.MOUSE_DOWN, fnHideShowTotal);
			hideShowTotal_btn.mouseChildren = false;
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			//added event for stage to move attached clip on mouse down and drag
			this.addEventListener(MouseEvent.MOUSE_DOWN, fnDragMoney);
			this.addEventListener(MouseEvent.MOUSE_UP, fnStopDragMoney);
		}
		
		//adds clicked money to stage and add events for the money
		private function fnAttachMoney(eve:MouseEvent):void{
			if(prevClip != null){
				prevClip.alpha = 1;
			}
			moneyCnt++;
			counter++;
			if(moneyCnt <= 100){
				var clipClass:Class = getDefinitionByName(eve.target.name + "_mc") as Class;
				var clip:MovieClip = new clipClass();
				money_mc.addChild(clip);
				clip.x = mouseX;
				clip.y = mouseY;
				clip.alpha = .8;//set alpha for current clip
				clip.name = eve.target.name + "_mc_" + counter;
				prevClip = clip;
				totMoney = totMoney + Number(eve.target.name.split("_")[1]);
				trace("totMoney = "+totMoney);
				display_mc.dispTxt.text = "$" + totMoney.toFixed(2);
				
			}			
		}
		
		private function fnDragMoney(eve:MouseEvent):void{
			//to find the clip clicked on stage comparing mouseX/mouseY and clip x and y
			for(var i:Number = money_mc.numChildren-1; i >= 0; i--){
				var clip:MovieClip = money_mc.getChildAt(i) as MovieClip
				if (mouseX >= clip.x -(clip.width/2) && mouseX <= clip.x + (clip.width/2) 
					&& mouseY >= clip.y -(clip.height/2) && mouseY<=clip.y+(clip.height/2)) {
					moveClip = clip;
				}
			}
			if(moveClip != null){
				if(prevClip != null){
					prevClip.alpha = 1;
				}
				moveClip.alpha = .8;
				prevClip = moveClip;
				moveClip.startDrag(false, new Rectangle(30, 20, 740, 460));
			}
		}
		
		private function fnStopDragMoney(eve:MouseEvent):void{
			if(moveClip != null){
				moveClip.stopDrag();
				moveClip = null;
			}
		}
		
		//deletes the selected clip
		private function fnDeleteSelected(eve:MouseEvent):void{
			if(prevClip != null){
				money_mc.removeChild(prevClip);				
				moneyCnt--;
				//trace(totMoney+"  DEL = "+Number(prevClip.name.split("_")[1]));
				totMoney = totMoney - Number(prevClip.name.split("_")[1]);
				totMoney = Number(totMoney.toFixed(2));
				//trace("totMoneyDEL = "+totMoney);
				prevClip = null;
				//display_mc.dispTxt.text = "$" + totMoney;
				display_mc.dispTxt.text = "$" + totMoney.toFixed(2);
			}
		}
		
		//displays total
		private function fnHideShowTotal(eve:MouseEvent):void{
			var clip:MovieClip = eve.target as MovieClip;
			var flag:Boolean;
			if(clip.showTotTxt_mc.visible){
				flag = true;
				clip.showTotTxt_mc.visible = false;
				clip.hideTotTxt_mc.visible = true;
			}else{
				flag = false;
				clip.showTotTxt_mc.visible = true;
				clip.hideTotTxt_mc.visible = false;
			}
			display_mc.visible = flag;
		}

		//removes the children from reference clip
		private function removeChildOf(clip:*):void{
			for(var i:Number = clip.numChildren-1; i >= 0; i--){
				clip.removeChild(clip.getChildAt(i));
			}
			trace("GANESJ = ");
		}
		
		//reset
		private function reset(eve:MouseEvent):void{
			removeChildOf(money_mc);
			moneyCnt = 0;
			counter = 0;
			totMoney = 0;
			display_mc.dispTxt.text = "$0.00";
			moveClip = null;
			prevClip = null;
		}
		
	}
}