﻿package com{
	
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.utils.getDefinitionByName;
	
	public class balance extends MovieClip{
		private var DataXml:XML;
		private var totalItems:Number;
		private var currItem:Number = 0;
		private var myBackDropImage;
		private var dragItem:MovieClip;
		private var duplicateItem:MovieClip;
		private var myStage;
		private var pan1Drop:Number = 0;
		private var pan2Drop:Number = 0;
		private var totalDrops = 4;
		private var totalWeigh = 0;
		private var maxWeigh = 8;
		private var pan1Weight = 0;
		private var pan2Weight = 0;
		private var initRotation = 0;
		
		public function balance(){
			myStage = this;
			LoadXml("xml/content.xml");
		}
		
		private function LoadXml(Url:String){
			var myURLLoader:URLLoader = new URLLoader();
			var myURLRequest:URLRequest = new URLRequest(Url);
			myURLLoader.load(myURLRequest);
			myURLLoader.addEventListener(Event.COMPLETE, onLoadXml);
			reset_btn.addEventListener(MouseEvent.CLICK, resetFunc);
		}
		
		private function onLoadXml(evt:Event){
			DataXml = new XML(evt.target.data);
			var myBdClass:String = DataXml.imageBackDrop.@classNam;
			var myClass:Class = getDefinitionByName(myBdClass) as Class;
			myBackDropImage = new myClass();
			myBackDropImage.x = DataXml.imageBackDrop.@xpos;
			myBackDropImage.y = DataXml.imageBackDrop.@ypos;
			myBackDropImage.name = "myBalance";
			addChild(myBackDropImage);
			var myBar = myBackDropImage.getChildByName("barMc");
			for(var i=1; i<=2; i++){
				var myPan = myBar.getChildByName("panMc"+i);
				var itemContainer:MovieClip = new MovieClip();
				itemContainer.name = "itemContainer";
				myPan.Num = i;
				myPan.addChild(itemContainer);
				var myPanBg = myPan.getChildByName("panBg");
				myPanBg.Num = i;
				myPanBg.addEventListener(MouseEvent.CLICK, onPanClick);
			}
			initRotation = myBar.rotation;
			totalItems = DataXml.itemList.item.length();
			totalWeigh = totalItems*maxWeigh;
			LoadItem(currItem);
		}
		
		private function LoadItem(Num:Number){
			var myLoader:Loader = new Loader();
			var myUrl:String = DataXml.itemList.item[Num];
			var myURLRequest:URLRequest = new URLRequest(myUrl);
			myLoader.load(myURLRequest);
			myLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadItem);
		}
		
		private function onPanClick(obj:MouseEvent){
			if(dragItem==null){
				var myBar = myBackDropImage.getChildByName("barMc");
				var myPan = myBar.getChildByName("panMc"+obj.currentTarget.Num);
				var myItemContainer = myPan.getChildByName("itemContainer");
				if(myItemContainer.numChildren>0){
					var myLastItem = myItemContainer.getChildAt(myItemContainer.numChildren-1);
					this["pan"+obj.currentTarget.Num+"Drop"] -= 1;
					this["pan"+obj.currentTarget.Num+"Weight"] -= myLastItem.wei;
					myItemContainer.removeChild(myLastItem);
				}
				checkBalance();
			}
		}
		
		private function resetFunc(obj:MouseEvent){
			pan1Drop = 0;
			pan2Drop = 0;
			pan1Weight = 0;
			pan2Weight = 0;			
			for (var i=1; i<=2; i++) {
				var myBar = myBackDropImage.getChildByName("barMc");
				var myPan = myBar.getChildByName("panMc"+i);
				var myItemContainer = myPan.getChildByName("itemContainer");
				while(myItemContainer.numChildren){
					myItemContainer.removeChildAt(0);
				}
			}
			checkBalance();
			if(dragItem != null){
				removeChild(duplicateItem);
				dragItem = null;
			}
		}
		
		private function onLoadItem(evt:Event){
			var myBitmap = Bitmap(evt.target.content);
			myBitmap.smoothing = true;
			var myItem = new MovieClip();
			myItem.addChild(myBitmap);
			myItem.name = "dragItem"+(currItem+1);
			myItem.Num = (currItem+1);
			myItem.wei = Number(DataXml.itemList.item[currItem].@wei);
			myItem.x = DataXml.itemList.item[currItem].@xpos;
			myItem.y = DataXml.itemList.item[currItem].@ypos;
			addChild(myItem);
			//myItem.addEventListener(MouseEvent.MOUSE_DOWN, onItemClick);
			if(++currItem<totalItems){
				LoadItem(currItem);
			}else{
				myItem = getChildByName("dragItem"+4);
				myItem.parent.setChildIndex(myItem, (myItem.parent.numChildren-1));
				myStage.addEventListener(MouseEvent.MOUSE_DOWN, onStagePress);
			}
		}
		
		private function onStagePress(obj:MouseEvent) {
			for (var j:int=1; j<=totalItems; j++) {
				var myItem=myStage.getChildByName("dragItem"+j);
				if (mouseX>=myItem.x&&mouseX<=myItem.x+(myItem.width)&&mouseY>=myItem.y&&mouseY<=myItem.y+(myItem.height)) {
					dragItemFunc(myItem as MovieClip);
				}
			}
		}
		
		private function dragItemFunc(obj:MovieClip){
			if(dragItem != null && duplicateItem.Num!=obj.Num){
				removeChild(duplicateItem);
				dragItem = null;
			}
			if(dragItem == null){
				duplicateItem = duplicateSmallPage(obj);
				duplicateItem.Num = obj.Num;
				duplicateItem.wei = obj.wei;
				dragItem = duplicateItem as MovieClip;
				duplicateItem.x = obj.x;
				duplicateItem.y = obj.y;
				addChild(duplicateItem);
				duplicateItem.startDrag(false, new Rectangle(10,10,600,450));
				duplicateItem.addEventListener(MouseEvent.MOUSE_UP, onDropItem);
			}
		}
		
		private function onDropItem(obj:MouseEvent){
			var myItemContainer;
			for (var i=1; i<=2; i++) {
				var myBar = myBackDropImage.getChildByName("barMc");
				var myPan = myBar.getChildByName("panMc"+i);
				//if (myPan.hitTestPoint(myStage.mouseX,myStage.mouseY)) {
				if (myPan.hitTestPoint(stage.mouseX,stage.mouseY)) {
					if(dragItem!=null){
						duplicateItem.stopDrag();
						this["pan"+i+"Drop"] += 1;
						if(this["pan"+i+"Drop"]>totalDrops){
							removeChild(duplicateItem);
							this["pan"+i+"Drop"] -= 1;
						}else{
							removeChild(duplicateItem);
							myItemContainer = myPan.getChildByName("itemContainer");
							myItemContainer.addChild(duplicateItem);
							var myTarget = myPan.getChildByName("target"+(this["pan"+i+"Drop"]));
							this["pan"+i+"Weight"]+=duplicateItem.wei;
							duplicateItem.x=myTarget.x;
							var panBg = myPan.getChildByName("panBg");
							duplicateItem.y=(panBg.height-duplicateItem.height-8);
							checkBalance();
						}
						dragItem=null;
					}else {
						myItemContainer = myPan.getChildByName("itemContainer");
						if(myItemContainer.numChildren>0){
							var myLastItem = myItemContainer.getChildAt(myItemContainer.numChildren-1);
							this["pan"+i+"Drop"] -= 1;
							this["pan"+i+"Weight"] -= myLastItem.wei;
							myItemContainer.removeChild(myLastItem);
						}
						checkBalance();
					}
				}
			}
		}
		
		private function checkBalance(){
			var weiDiff = (pan2Weight-pan1Weight)*totalItems;
			var myBar = myBackDropImage.getChildByName("barMc");
			myBar.rotation=initRotation;
			if(weiDiff<0){
				myBar.rotation=weiDiff;
				if(weiDiff<(-totalWeigh)){
					myBar.rotation=-totalWeigh;
				}
			}else{
				myBar.rotation=weiDiff;
				if(weiDiff>totalWeigh){
					myBar.rotation=totalWeigh;
				}
			}
			for(var i=1; i<=2; i++){
				var myPan = myBar.getChildByName("panMc"+i);
				myPan.rotation=-(myBar.rotation);
			}
		}
		
		private function duplicateSmallPage(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);
			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
	}
}