﻿package com 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.geom.Rectangle;
	//import fl.text.TLFTextField;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	
	public class Main extends MovieClip 
	{
		private var xmlLoader		: URLLoader;
		private var data			: XML;
		private var rangeStart		: Number;
		private var rangeEnd		: Number;
		private var numberOfItem	: Number;
		private var currObj;
		
		public function Main() 
		{
			this.addEventListener(Event.ADDED_TO_STAGE, onAdded);			
		}
		
		private function onAdded(evt:Event = null):void {
			setting_mc.visible = false;
			xmlLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			xmlLoader.load(new URLRequest("xml/config.xml"));
		}
		
		private function onXMLLoaded(evt:Event):void {
			var button:MovieClip;
			data = new XML(evt.target.data);
			rangeStart = Number(data.range.start.toString());
			rangeEnd = Number(data.range.end.toString());
			numberOfItem = 1;
			createDragElement();	
			setting_mc.save_btn.alpha =0;
			setting_mc.save_btn.visible=false;
			shuffle_btn.addEventListener(MouseEvent.CLICK, onShuffleElement);
			setting_btn.addEventListener(MouseEvent.CLICK, onSetting);
			setting_mc.start_up.addEventListener(MouseEvent.CLICK, onStartUp);
			setting_mc.start_down.addEventListener(MouseEvent.CLICK, onStartDown);
			setting_mc.end_up.addEventListener(MouseEvent.CLICK, onEndUp);
			setting_mc.end_down.addEventListener(MouseEvent.CLICK, onEndDown);
			setting_mc.save_btn.addEventListener(MouseEvent.CLICK, onSave);
			setting_mc.mc_start.title.text = rangeStart;
			setting_mc.mc_end.title.text = rangeEnd;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			for (var i:int = 1; i <= 6; i++) {
				button = setting_mc.getChildByName("btn_" + i) as MovieClip;
				button.mouseChildren = false;
				button.buttonMode = true;
				button.useHandCursor = true;
				button.addEventListener(MouseEvent.CLICK, onUpdateNumberOfItem);
				button.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
				button.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
				button.gotoAndStop(1);
				if ( numberOfItem == i ) {
					button.gotoAndStop(3);
					button.removeEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					button.removeEventListener(MouseEvent.MOUSE_OUT, onMouseOut);button.gotoAndStop(3);
					
				} 
			}
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		
		public function onMouseOver(eve:MouseEvent =null){
			var btn_mc = eve.target
			btn_mc.gotoAndStop(2)
		}
		public function onMouseOut(eve:MouseEvent =null){
			var btn_mc = eve.target
			btn_mc.gotoAndStop(1)
		}
		public function onReset(evt:MouseEvent = null ) {
			var drag:MovieClip;
			var button:MovieClip;
			numberOfItem = 1;
			for (var i:int = 0; i < Number(data.content.@numberOfDrag); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				if ( drag != null ) {
					removeChild(drag);
				}
			}
			for (i = 1; i <= 6; i++) {
				button = setting_mc.getChildByName("btn_" + i) as MovieClip;
				button.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
				button.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
				button.gotoAndStop(1);
				if ( numberOfItem == i ) {
					button.gotoAndStop(3);
					button.removeEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					button.removeEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
				} 
			}
			setting_mc.mc_start.title.text = rangeStart;
			setting_mc.mc_end.title.text = rangeEnd;
			createDragElement();
			setting_mc.visible = false;
		}
		
		private function onSave(evt:MouseEvent):void {
			var drag:MovieClip;
			for (var i:int = 0; i < Number(data.content.@numberOfDrag); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				if ( drag != null ) {
					removeChild(drag);
				}
			}
			createDragElement();
			setting_mc.visible = false;
		}
		
		private function onUpdateNumberOfItem(evt:MouseEvent):void {
			var button:MovieClip = evt.target as MovieClip;
			var startNumber:Number = Number(setting_mc.mc_start.title.text);
			var endNumber:Number = Number(setting_mc.mc_end.title.text);
			numberOfItem = Number(button.name.split("_")[1]);
			//trace(numberOfItem+"numberOfItem:::::::")
			for (var i:int = 1; i <= 6; i++) {
				button = setting_mc.getChildByName("btn_" + i) as MovieClip;
				button.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
				button.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
				button.gotoAndStop(1);
				if ( numberOfItem == i ) {
					button.gotoAndStop(3);
					button.removeEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					button.removeEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
				}
			}
			if ( numberOfItem >= (endNumber)+2 ) {				
				setting_mc.mc_end.title.text = startNumber+(numberOfItem - 1)
				////trace("greater")
			}else  if (startNumber < endNumber)
			{
				////trace("equal")
				//setting_mc.mc_end.title.text = startNumber+(numberOfItem-1)
			}
			
			
		}
		
		private function onStartUp(evt:MouseEvent):void {
			var startNumber:Number = Number(setting_mc.mc_start.title.text);
			var endNumber:Number = Number(setting_mc.mc_end.title.text);
			if ( startNumber <= (endNumber - numberOfItem) ) {
				startNumber++;
			}
			setting_mc.mc_start.title.text = startNumber;
		}
		
		private function onStartDown(evt:MouseEvent):void {
			var startNumber:Number = Number(setting_mc.mc_start.title.text);
			if ( startNumber >= (rangeStart+1) ) {
				startNumber--;
			}
			setting_mc.mc_start.title.text = startNumber;
		}
		
		private function onEndUp(evt:MouseEvent):void {
			var endNumber:Number = Number(setting_mc.mc_end.title.text);
			if ( endNumber < rangeEnd ) {
				endNumber++;
			}
			setting_mc.mc_end.title.text = endNumber;
		}
		
		private function onEndDown(evt:MouseEvent):void {
			var endNumber:Number = Number(setting_mc.mc_end.title.text);
			var startNumber:Number = Number(setting_mc.mc_start.title.text);
			if ( endNumber >= (startNumber+numberOfItem) ) {
				endNumber--;
			}
			setting_mc.mc_end.title.text = endNumber;
		}
		
		private function onShuffleElement(evt:MouseEvent):void {
			var drag:MovieClip;
			for (var i:int = numChildren - 1; i >= 0; i--) {
				if ( getChildAt(i).name.split("_")[0] == "drag" ) {
					removeChildAt(i);
				}
			}
			createDragElement();
		}
		
		private function onSetting(evt:MouseEvent):void {
			if ( !setting_mc.visible ) {
				setting_mc.visible = true;
			} else {
				setting_mc.visible = false;
			}
		}
		
		private function createDragElement():void {
			var drag:MovieClip;
			var txtFld:TextField;
			var txtFormat:TextFormat;
			var startNumber:Number;
			var endNumber:Number;
			var dragNumber:Array = new Array();
			var rand:Number;
			var flag:Boolean;
			startNumber = setting_mc.mc_start.title.text;
			endNumber = setting_mc.mc_end.title.text;
			txtFormat = new TextFormat();
			var fnt=getDefinitionByName(data.content.@fontId) as Class;
			var fon:Font=new fnt();
			txtFormat.font = fon.fontName;
			txtFormat.size = Number(data.content.@fontSize);
			txtFormat.color = uint(data.content.@fontColor);
			while (dragNumber.length != numberOfItem) {
				flag = false;
				rand = Math.floor(Math.random() * (endNumber - startNumber + 1)) + startNumber;
				for(var j:int = 0; j < dragNumber.length; j++) {
					if ( dragNumber[j] == rand ) {
						flag = true;
						j = dragNumber.length;
					}
				}
				if ( !flag ) {
					dragNumber.push(rand);
				}
			}
			for (var i:int = 0; i < numberOfItem; i++) {
				drag = new MovieClip();
				drag.name = "drag_" + i;
				drag.mouseChildren = false;
				drag.tabEnabled = false;
				drag.tabChildren = false;
				drag.graphics.lineStyle(Number(data.content.sentences.@borderSize), Number(data.content.sentences.@borderColor), 1);
				drag.graphics.beginFill(Number(data.content.sentences.@backgroundColor), 1);
				drag.graphics.drawRect(0, 0, Number(data.content.sentences.@width), Number(data.content.sentences.@height));
				drag.x = Number(data.content.sentences.sentence[numberOfItem-1].item[i].@xpos);
				drag.y = Number(data.content.sentences.sentence[numberOfItem-1].item[i].@ypos);
				addChild(drag);
				txtFld = new TextField();
				txtFld.text = dragNumber[i] + "";
				txtFld.selectable = false;
				txtFld.embedFonts=true;
				txtFld.autoSize = "left";
				txtFld.setTextFormat(txtFormat);
				txtFld.x = drag.width / 2 - txtFld.width / 2 - 2;
				txtFld.y = drag.height / 2 - txtFld.height / 2;
				drag.addChild(txtFld);					
				drag.addEventListener(MouseEvent.MOUSE_DOWN, onDragStart);
				drag.addEventListener(MouseEvent.MOUSE_UP, onDragStop);
			}
		}
		
		private function onDragStart(obj:MouseEvent){
			currObj = obj.currentTarget;
			obj.currentTarget.parent.setChildIndex(obj.currentTarget, (obj.currentTarget.parent.numChildren-1));
			obj.currentTarget.startDrag(false, new Rectangle(20, 20, 600, 245));
			obj.currentTarget.stage.addEventListener(MouseEvent.MOUSE_UP, onDragStop);
		}
		
		private function onDragStop(obj:MouseEvent){
			currObj.stopDrag();
			currObj.stage.removeEventListener(MouseEvent.MOUSE_UP, onDragStop);
		}
		
	}

}