﻿package com{
	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	public class BreadFrame extends MovieClip{
		private var XMLData:XML=new XML();
		private var PosArray:Array=new Array();
		private var CountersArray:Array=new Array();
		private var Btn20:counter=new counter();
		private var Btn100:counter2=new counter2();
		private var shT:shtotal=new shtotal();
		private var hT:htotal=new htotal();
		private var FrameMc:MovieClip=new MovieClip();
		private var CurrentFrame:Number=1;
		private var TotalText:TotalTxt=new TotalTxt();
		
		public function BreadFrame() {
			LoadXMLData();
		}
		private function LoadXMLData():void
		{
			var xmlLoaderObj:URLLoader=new URLLoader();
			xmlLoaderObj.load(new URLRequest("xml/BreadFrame.xml"));
			xmlLoaderObj.addEventListener(Event.COMPLETE,onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLData=XML((e.currentTarget).data);
			addChild(FrameMc);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));		
			CreateActivity();
		}
		private function CreateActivity():void
		{
			CreateFrame(1);
			AddButtons();
			AddTotalText();				
		}
		private function CreateFrame(id:int):void
		{
			CurrentFrame=id;
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(1,XMLData.Frame.@borderColor);
			g.beginFill(uint(XMLData.Frame.@fillColor));
			g.drawRect(0,0,XMLData.Info.Frame[id].@width,XMLData.Info.Frame[id].@height);				
			g.endFill();
			FrameMc.addChild(sh);
			sh.x=XMLData.Info.Frame[id].@xpos;
			sh.y=XMLData.Info.Frame[id].@ypos;		
			AddRows(id);
			TotalText.txt.text=""+CalculateTotal();
		}
		private function AddRows(ind:int):void
		{
			PosArray=new Array();
			var Num_Rows:int=XMLData.Info.Frame[ind].@num_Rect;
			var StartY:int=int(XMLData.Info.Frame[ind].@ypos)+10;		
			var dist:int= (int(XMLData.Info.Frame[ind].@height)/Num_Rows);
			for(var i:int=0;i<Num_Rows;i++)
			{
				var Obj:Object=new Object();
				var sh:Shape=new Shape();
				var g:Graphics=sh.graphics;
				g.lineStyle(1,XMLData.Frame.@rectBorderColor);
				g.beginFill(XMLData.Frame.@rectFillColor);
				g.drawRect(0,0,XMLData.Info.Frame[ind].@width-24,20);			
				g.endFill();
				sh.x=12+Number(XMLData.Info.Frame[ind].@xpos);
				sh.y=StartY;
				StartY+=dist;
				FrameMc.addChild(sh);
				
				Obj.x=sh.x;
				Obj.y=sh.y;
				PosArray.push(Obj);
			}
			AddCounters(ind);			
		}
		private function AddCounters(id:int):void
		{
			CountersArray=new Array();
			var Num_Rows:int=XMLData.Info.Frame[id].@num_Rect;
			var Num_Counters:int=XMLData.Info.Frame[id].@num_Counter;
			for(var i:int=0;i<Num_Rows-1;i++)
			{
				var StartX:Number=PosArray[i].x;
				CountersArray[i]=new Array();
				for(var j:int=0;j<Num_Counters;j++)
				{
					var Obj:Object=new Object();
					var sh:MovieClip=new MovieClip();
					var g:Graphics=sh.graphics;
					if(j<(Num_Counters/2))
					{
						g.lineStyle(1,XMLData.Counter.@borderColor1);
						g.beginFill(XMLData.Counter.@fillColor1);
					}else
					{
						g.lineStyle(1,XMLData.Counter.@borderColor2);
						g.beginFill(XMLData.Counter.@fillColor2);
					}			
					g.drawEllipse(0,0,XMLData.Counter.@width,XMLData.Counter.@height);
					g.endFill();
					
					FrameMc.addChild(sh);
					sh.x=StartX+2;
					sh.y=PosArray[i].y+12;
					sh.id=j;
					sh.index=i;
					sh.direction="left";
					sh.buttonMode=true;
					
					sh.addEventListener(MouseEvent.CLICK,MoveIt);
					StartX+=Number(XMLData.Counter.@width);				
					CountersArray[i].push(sh);
				}
			}
		}
		private function AddButtons():void
		{
			addChild(Btn20);
			addChild(Btn100);
			Btn20.buttonMode=true;
			Btn20.mouseChildren=false;
			Btn100.buttonMode=true;
			Btn100.mouseChildren=false;
			
			Btn20.x=XMLData.Btn20.@xpos;
			Btn20.y=XMLData.Btn20.@ypos;
			Btn20.gotoAndStop(1);
			Btn20.addEventListener(MouseEvent.MOUSE_OVER,overState);
			Btn20.addEventListener(MouseEvent.MOUSE_OUT,outState);
			Btn20.addEventListener(MouseEvent.CLICK,Frame20);
			
			
			Btn100.x=XMLData.Btn100.@xpos;
			Btn100.y=XMLData.Btn100.@ypos;
			Btn100.gotoAndStop(3);
			Btn100.mouseEnabled=false;
			Btn100.addEventListener(MouseEvent.MOUSE_OVER,overState);
			Btn100.addEventListener(MouseEvent.MOUSE_OUT,outState);
			Btn100.addEventListener(MouseEvent.CLICK,Frame100);
			
			addChild(shT);
			addChild(hT);
			
			hT.visible=false;
			shT.buttonMode=true;
			hT.buttonMode=true;
			
			
			shT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			shT.addEventListener(MouseEvent.MOUSE_OUT,outState);
			hT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			hT.addEventListener(MouseEvent.MOUSE_OUT,outState);
			shT.addEventListener(MouseEvent.CLICK,showTotal);
			hT.addEventListener(MouseEvent.CLICK,hideTotal);
			
			shT.x=hT.x=XMLData.ShowHideBtn.@xpos;
			shT.y=hT.y=XMLData.ShowHideBtn.@ypos;			
		}
		private function Frame20(e:MouseEvent):void
		{
			Btn100.gotoAndStop(1);
			Btn20.gotoAndStop(3);
			Btn20.mouseEnabled=false;
			Btn100.mouseEnabled=true;
			RemoveFrame();
			CreateFrame(0);
		}
		private function Frame100(e:MouseEvent):void
		{
			Btn100.gotoAndStop(3);
			Btn20.gotoAndStop(1);
			Btn20.mouseEnabled=true;
			Btn100.mouseEnabled=false;
			RemoveFrame();
			CreateFrame(1);
		}
		public function onReset(e:MouseEvent=null):void
		{
			RemoveFrame();
			TotalText.txt.text="0";
		}
		private function RemoveFrame():void
		{			
			for(var i:int=FrameMc.numChildren-1;i>=0;i--)
			{
				FrameMc.removeChildAt(i);
			}
		}
		private function MoveIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			var W:Number=FrameMc.width+24;			
			if(tar.direction=="left")
			{					
				for(var i:int=tar.id;i<CountersArray[tar.index].length;i++)
				{
					var dist:Number=(tar.width-1)*(CountersArray[tar.index].length-CountersArray[tar.index][i].id);
					CountersArray[tar.index][i].x=Number(XMLData.Info.Frame[CurrentFrame].@width)+Number(XMLData.Info.Frame[CurrentFrame].@xpos)-dist-13;
					CountersArray[tar.index][i].direction="right";
				}
			}
			else if(tar.direction=="right")
			{
				for(i=tar.id;i>=0;i--)
				{
					if(CountersArray[tar.index][i].direction=="right")
					{
						dist=(tar.width-1)*(CountersArray[tar.index][i].id);
						CountersArray[tar.index][i].x=Number(XMLData.Info.Frame[CurrentFrame].@xpos)+dist+14;
						CountersArray[tar.index][i].direction="left";
					}
					
				}
			}
			TotalText.txt.text=""+CalculateTotal();
		}
		private function AddTotalText():void
		{
			addChild(TotalText);
			TotalText.x=XMLData.TotalText.@xpos;
			TotalText.y=XMLData.TotalText.@ypos;
			TotalText.txt.text="0";
			TotalText.visible=false;
		}
		private function showTotal(e:MouseEvent):void
		{
			shT.visible=false;
			hT.visible=true;
			TotalText.visible=true;
			TotalText.txt.text=""+CalculateTotal();
		}
		private function hideTotal(e:MouseEvent):void
		{
			shT.visible=true;
			hT.visible=false;
			TotalText.visible=false;
		}
		private function CalculateTotal():Number
		{			
			var Total:Number=new Number();
			for(var i:int=0;i<CountersArray.length;i++)
			{
				for(var j:int=0;j<CountersArray[i].length;j++)
				{
					if(CountersArray[i][j].direction=="right")
					{
						Total+=1;
					}
				}
			}
			return Total;
		}
		private function overState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOver(Tar);
		}
		private function outState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOut(Tar);
		}
		private function showOver(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(2);
			}
		}
		private function showOut(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(1);
			}
		}
	}	
}
