﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flashx.textLayout.formats.Float;

	public class NumberLine_Patterns extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var NumbersArray:Array=new Array();
		private var DropAreaArray:Array=new Array();
		private var DragObj:MovieClip=new MovieClip();
		private var LinesArray:Array=new Array();
		private var HighlightLine:MovieClip=new MovieClip();
		private var CurrentPattern:Number=0;
		private var NLArray:Array=new Array();
		private var filllineClicked:Boolean=false;
		private var NumLines:Number=new Number();
		private var AutoCorrectOn:Boolean=false;
		private var ATCONOFF:autoCorrect_mc;
		
		private var sw:Number=760;
		private var sh:Number=420;
			
		public function NumberLine_Patterns()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO1_17.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			addChild(HighlightLine);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			feedback.mouseEnabled=false;
			AddControlBtns();
			AddHorizontalLine();
			AddVerticalLines(21);			
			AddNumbersPanel();
			AddNumbers();
			
			AddResetBtn();
			AddFrog();
			
		}
		
		private function AddHorizontalLine():void
		{
			////////////////////Draw Horizontal Line/////////////////
			var HLine:Shape=new Shape();
			HLine.graphics.lineStyle(XMLObj.HorizontalLine.@thickness,XMLObj.HorizontalLine.@color);
			HLine.graphics.moveTo(0,0);
			HLine.graphics.lineTo(XMLObj.HorizontalLine.@width,0);
			
			///////////////Draw arrowheads//////////////////////
			HLine.graphics.beginFill(XMLObj.HorizontalLine.@fillColor);
			HLine.graphics.moveTo(-5,0);
			HLine.graphics.lineTo(0,-5);
			HLine.graphics.lineTo(0,5);
			HLine.graphics.lineTo(-5,0);
			
			
			HLine.graphics.moveTo(Number(XMLObj.HorizontalLine.@width)+5,0);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width),-5);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width),5);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width)+5,0);
			
			HLine.graphics.endFill();
			
			addChild(HLine);
			
			HLine.x=XMLObj.HorizontalLine.@xpos;
			HLine.y=XMLObj.HorizontalLine.@ypos;
		}
		private function AddVerticalLines(Count:int):void
		{
			NumLines=Count;
			feedback.alpha=0;
			var StartX:Number=Number(XMLObj.VerticalLines.@startXpos);
			var StartY:Number=Number(XMLObj.VerticalLines.@startYpos);
			for(var i:int=0;i<NumLines;i++)
			{
				var VLine:MovieClip=new MovieClip();
				VLine.name="line_"+(i+1);
				VLine.id=i;
				LinesArray.push(VLine);
				
				var g:Graphics=VLine.graphics;
				g.lineStyle(Number(XMLObj.VerticalLines.@thickness));
				g.moveTo(0,0);
				g.lineTo(0,XMLObj.VerticalLines.@height);
				var gap:Number=Number(XMLObj.HorizontalLine.@width)/(Count+1);
				StartX+=gap;
				VLine.x=StartX;
				VLine.y=StartY;				
				addChild(VLine);				
				
				
				var mc:MovieClip=CreateHitArea();
				mc.name="drop_"+i;
				mc.id=i;
				mc.x=StartX-mc.width/2;
				mc.y=StartY+Number(XMLObj.VerticalLines.@height)+5;
				addChild(mc);
				mc.alpha=0;
				DropAreaArray.push(mc);
				
			}
		}
		private function CreateHitArea():MovieClip
		{
			var mc:MovieClip=new MovieClip();
			var sh:Shape=new Shape();
			sh.graphics.lineStyle(1,0x000000);
			sh.graphics.beginFill(0xffffff,1);
			sh.graphics.drawRect(0,0,XMLObj.Words.@width,XMLObj.Words.@height);
			sh.graphics.endFill();
			mc.addChild(sh);
			mc.mouseChildren=false;
			return mc;
		}
		private function CreateMC(Str:String):MovieClip
		{
			var mc:MovieClip=new MovieClip();
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.autoSize="left";
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			TxtFld.text=Str;
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			if(NumLines == 11){
				TF.size=XMLObj.Words.@FontSize1;
			}else if(NumLines == 21){
				TF.size=XMLObj.Words.@FontSize2;
			}else{
				TF.size=XMLObj.Words.@FontSize3;
			}
			TF.color=XMLObj.Words.@FontColor;
			TF.align=TextFormatAlign.CENTER;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			var sh:Shape=new Shape();
			sh.graphics.lineStyle(1,0x000000,0);
			sh.graphics.beginFill(0xffffff,0);
			sh.graphics.drawRect(0,0,TxtFld.width+2,TxtFld.height+2);
			sh.graphics.endFill();
			
			TxtFld.x=TxtFld.y=1;
			mc.addChild(sh);
			mc.addChild(TxtFld);
			
			mc.buttonMode=true;
			return mc;
			
		}
		private function AddNumbersPanel():void
		{
			var panel:Shape=new Shape();
			var G:Graphics=panel.graphics;
			G.lineStyle(1,XMLObj.NumberPanel.@linecolor);
			G.beginFill(XMLObj.NumberPanel.@fillcolor,XMLObj.NumberPanel.@fillalpha);
			G.drawRect(0,0,XMLObj.NumberPanel.@width,XMLObj.NumberPanel.@height);
			G.endFill();
			addChild(panel);
			panel.x=XMLObj.NumberPanel.@xpos;
			panel.y=XMLObj.NumberPanel.@ypos;			
		}
		private function AddNumbers():void
		{
			for(var i:int=0;i<NumLines;i++)
			{
				var mc:MovieClip=CreateMC(""+i);
				mc.id=i;
				mc.mouseChildren=false;
				mc.buttonMode=true;
				addChild(mc);
				NumbersArray.push(mc);
				mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
			NumbersArray=ShuffledArray();
			
			var StartX:Number=Number(XMLObj.NumberPanel.@xpos) + 5;
			var StartY:Number=Number(XMLObj.NumberPanel.@ypos) + 10;
			for(i=0;i<NumbersArray.length;i++)
			{
				if(NumbersArray.length == 11){
					NumbersArray[i].xpos=NumbersArray[i].x=XMLObj.NumberPos.alignment[0].pos[i].@xPos;
					NumbersArray[i].ypos=NumbersArray[i].y=XMLObj.NumberPos.alignment[0].pos[i].@yPos;					
				}else if(NumbersArray.length == 21){
					NumbersArray[i].xpos=NumbersArray[i].x=XMLObj.NumberPos.alignment[1].pos[i].@xPos;
					NumbersArray[i].ypos=NumbersArray[i].y=XMLObj.NumberPos.alignment[1].pos[i].@yPos;					
				}else{
					NumbersArray[i].xpos=NumbersArray[i].x=StartX;
					NumbersArray[i].ypos=NumbersArray[i].y=StartY;
					if((StartX+NumbersArray[i].width)<(Number(XMLObj.NumberPanel.@xpos)-75+Number(XMLObj.NumberPanel.@width)))
					{
						StartX+=NumbersArray[i].width+50;
					}else
					{
						StartY = StartY + NumbersArray[i].height + 15;
						StartX=Number(XMLObj.NumberPanel.@xpos) + 5;
					}
				}
				
			}
			if(filllineClicked)
			{
				showText();
			}
		}
		private function ShuffledArray():Array
		{			
			var shuffledLetters:Array = new Array(NumbersArray.length); 
			var emptySlots:Array = new Array();
			for (var n:int = 0; n < NumbersArray.length; n++){    
				emptySlots.push(n);
			} 
			var randomPos:Number = 0;
			var actualSlot:Number = 0;
			for (var i:int = 0; i < NumbersArray.length; i++){    
				randomPos = int(Math.random() * emptySlots.length); 
				actualSlot = emptySlots[randomPos];    
				shuffledLetters[actualSlot] = NumbersArray[i];    
				emptySlots.splice(randomPos, 1);
			}
			return shuffledLetters;
		}
		private function AddControlBtns():void
		{
			NLArray=new Array();
			var Len:Number=XMLObj.Buttons.NL.NL.length();
			for(var i:int=0;i<Len;i++)
			{
				var cl=getDefinitionByName("NUL"+(i+1)) as Class;
				var btn:MovieClip=new cl();
				addChild(btn);
				btn.buttonMode=true;
				btn.count=int(XMLObj.Buttons.NL.NL[i].@count);
				btn.mouseChildren=false;
				btn.gotoAndStop(1);
				btn.x=XMLObj.Buttons.NL.NL[i].@xpos;
				btn.y=XMLObj.Buttons.NL.NL[i].@ypos;
				NLArray.push(btn);
				btn.addEventListener(MouseEvent.MOUSE_OVER,overState);
				btn.addEventListener(MouseEvent.MOUSE_OUT,outState);
				btn.addEventListener(MouseEvent.CLICK,changeLines);
			}
			NLArray[1].gotoAndStop(3);
			
			var FillLine:FL=new FL();
			addChild(FillLine);
			FillLine.x=XMLObj.Buttons.FL.@xpos;
			FillLine.y=XMLObj.Buttons.FL.@ypos;
			FillLine.addEventListener(MouseEvent.CLICK,showText);
			
			ATCONOFF = new autoCorrect_mc();
			addChild(ATCONOFF);
			ATCONOFF.x=XMLObj.Buttons.ATCONOFF.@xpos;
			ATCONOFF.y=XMLObj.Buttons.ATCONOFF.@ypos;
			ATCONOFF.off_btn.visible = false;
			ATCONOFF.off_btn.addEventListener(MouseEvent.CLICK,AutoCorrect);
			ATCONOFF.on_btn.addEventListener(MouseEvent.CLICK,AutoCorrect);
		}
		private function showText(e:MouseEvent=null):void
		{
			filllineClicked=true;
			for(var i:int=0;i<NumbersArray.length;i++)
			{
				for(var j:int=0;j<DropAreaArray.length;j++)
				{
					if(NumbersArray[i].id==j)
					{
						if(j<10)
						{
							NumbersArray[i].x=DropAreaArray[j].x+5;
						}else
						{
							NumbersArray[i].x=DropAreaArray[j].x+2;
						}
						NumbersArray[i].y=DropAreaArray[j].y;
						NumbersArray[i].Target=DropAreaArray[j];
						DropAreaArray[i].droppedItem=NumbersArray[i];
					}
				}
			}
		}
		private function fnDragFrog(eve:MouseEvent):void{
			eve.currentTarget.startDrag(false,new Rectangle(0, 0, 700, 480));
			eve.currentTarget.addEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
			stage.addEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
		}
		
		private function fnStopFrogDrag(eve:MouseEvent):void{
			eve.currentTarget.stopDrag();
			eve.currentTarget.removeEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
			stage.removeEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
		}
		private function AddFrog():void{
			var f:MovieClip=new frog();
			addChild(f);
			f.x=Number(XMLObj.HorizontalLine.@xpos);
			f.y=Number(XMLObj.HorizontalLine.@ypos)-f.height-4;
			f.addEventListener(MouseEvent.MOUSE_DOWN, fnDragFrog);
		}		
		private function AddResetBtn():void
		{		
			reset_btn.addEventListener(MouseEvent.CLICK,reset);		
		}		
		
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			setChildIndex(DragObj,numChildren-1);
			DragObj.startDrag(false,new Rectangle(0,0,sw-DragObj.width,sh-DragObj.height));
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			if(DragObj.Target)
			{
				DragObj.Target.droppedItem=null;
				DragObj.Target=null;
			}
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{
				var Bool:Boolean=false;
				for(var j:int=0;j<DropAreaArray.length;j++)
				{
					if(DragObj.hitTestObject(DropAreaArray[j]))
					{
						if(DropAreaArray[j].droppedItem)
						{
							DropAreaArray[j].droppedItem.x=DropAreaArray[j].droppedItem.xpos;
							DropAreaArray[j].droppedItem.y=DropAreaArray[j].droppedItem.ypos;
							DropAreaArray[j].droppedItem.Target=null;
							DropAreaArray[j].droppedItem=null;
						}
						if(AutoCorrectOn)
						{
							if(DragObj.id==DropAreaArray[j].id)
							{
								if(DragObj.id<10)
								{
									DragObj.x=DropAreaArray[j].x+5;
								}else
								{
									DragObj.x=DropAreaArray[j].x+2;
								}
								
								DragObj.y=DropAreaArray[j].y;
								DropAreaArray[j].droppedItem=DragObj;
								DragObj.Target=DropAreaArray[j];
							}else
							{
								DragObj.x=DragObj.xpos;
								DragObj.y=DragObj.ypos;
								DropAreaArray[j].droppedItem=null;
								DragObj.Target=null;
							}
							
						}else
						{							
							if(DragObj.id<10)
							{
								DragObj.x=DropAreaArray[j].x+5;
							}else
							{
								DragObj.x=DropAreaArray[j].x+2;
							}
							
							DragObj.y=DropAreaArray[j].y;
							DropAreaArray[j].droppedItem=DragObj;
							DragObj.Target=DropAreaArray[j];
						}
						Bool=true;
						break;
					}
				}
				if(!Bool)
				{					
					DragObj.x=DragObj.xpos;
					DragObj.y=DragObj.ypos;
					if(DragObj.Target)
					{
						DragObj.Target.droppedItem=null;
					}
					DragObj.Target=null;
				}
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				DragObj.stopDrag();
				DragObj=null;
			}
			Validate();
		}
		private function Validate():void
		{
			var Counting:int=0;
			for(var i:int=0;i<NumbersArray.length;i++)
			{
				if(NumbersArray[i].Target && NumbersArray[i].id==NumbersArray[i].Target.id)
				{
					Counting++;
				}
			}
			if(Counting==NumLines)
			{
				feedback.alpha=1;
			}else
			{
				feedback.alpha=0;
			}
		}
		private function RemoveLines():void
		{
			for(var i:int=0;i<LinesArray.length;i++)
			{
				removeChild(LinesArray[i]);
				if(NumbersArray[i])
				{
					removeChild(NumbersArray[i]);
				}
				if(DropAreaArray[i])
				{
					removeChild(DropAreaArray[i]);
				}
			}
			LinesArray=new Array();
			NumbersArray=new Array();
			DropAreaArray=new Array();
		}
		public function reset(e:MouseEvent):void
		{
			filllineClicked=false;
			AutoCorrectOn=false;
			RemoveLines();
			ATCONOFF.off_btn.visible = false;
			ATCONOFF.on_btn.visible = true;
			for(var i:int=0;i<NLArray.length;i++)
			{
				NLArray[i].gotoAndStop(1);
				NLArray[i].mouseEnabled=true;
			}
			NLArray[1].gotoAndStop(3);
			NLArray[1].mouseEnabled=false;
			
			var lines:int=NLArray[1].count;
			AddVerticalLines(lines);
			AddNumbers();
			
		}
		private function overState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			if(Tar.currentFrame!=3)
			{
				Tar.gotoAndStop(2);
			}
		}
		private function outState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			if(Tar.currentFrame!=3)
			{
				Tar.gotoAndStop(1);
			}
		}
		private function changeLines(e:MouseEvent):void
		{
			RemoveLines();
			for(var i:int=0;i<NLArray.length;i++)
			{
				NLArray[i].gotoAndStop(1);
				NLArray[i].mouseEnabled=true;
			}
			MovieClip(e.currentTarget).gotoAndStop(3);
			MovieClip(e.currentTarget).mouseEnabled=false;
			
			var lines:int=MovieClip(e.currentTarget).count;
			AddVerticalLines(lines);
			AddNumbers();
		}
		private function AutoCorrect(e:MouseEvent):void
		{
			AutoCorrectOn=!AutoCorrectOn;
			if(AutoCorrectOn)
			{
				for(var i:int=0;i<NumbersArray.length;i++)
				{
					if(NumbersArray[i].Target && NumbersArray[i].id==NumbersArray[i].Target.id)
					{
						
					}else
					{
						NumbersArray[i].x=NumbersArray[i].xpos;
						NumbersArray[i].y=NumbersArray[i].ypos;
						NumbersArray[i].Target=null;
					}
				}
				ATCONOFF.off_btn.visible = true;
				ATCONOFF.on_btn.visible = false;
			}else{
				ATCONOFF.off_btn.visible = false;
				ATCONOFF.on_btn.visible = true;
			}
			Validate();
		}
	}
}