﻿package com{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Rectangle;
	
	public class Calculator{
		var mainMc:MovieClip;
		var my_txt:TextField;
		var stack:Array = new Array();
		var operArr:Array = ["+", "-", "*", "/"];
		var userTextArr:Array = [];
		var userText = "";
		var userUnitTest = "";
		var totDigits = 16;
		var stackSize = 12;
		var dispValue = 0;          
		var level = 0;          
		var enteredVal = true;    
		var decimal = 0;               
		var fixed = 0;          
		var exponent = false;
		var expval = 0;
		var prec = 0;
		var inverse = false;    
		var memory;
		var digits;
		var digitEntered = 0;
		var equalClicked = 0;
		var equationEntered = 0;
		var moveVal=1;
		var moveArea = 0;
		var currOper="";
		var currSecVal=0;
		var txtUpBtn:MovieClip;
		var txtDownBtn:MovieClip;
		var txtDragMc:MovieClip;
		var txtBarMc:MovieClip;
		
		public function Calculator(sMC, mTx, up, down, drag, bar){
			mainMc = sMC;
			my_txt = mTx;
			my_txt.text = "0";
			txtUpBtn = up;
			txtDownBtn = down;
			txtDragMc = drag;
			txtBarMc = bar;
			moveArea = (txtBarMc.height-txtDragMc.height);
			assignAction();
			initArray();
		}
		
		private function assignAction(){
			for(var i=0; i<=9; i++){
				var numClip:MovieClip = mainMc["b"+i];
				numClip.num = i;
				numClip.buttonMode = true;
				numClip.addEventListener(MouseEvent.CLICK, setTxt);
			}
			for(var j=1; j<=operArr.length; j++){
				var operClip:MovieClip = mainMc["opBtn"+j];
				operClip.oper = operArr[j-1];
				operClip.buttonMode = true;
				operClip.addEventListener(MouseEvent.CLICK, setOper);
			}
			mainMc.equalBtn.buttonMode = true;
			mainMc.equalBtn.addEventListener(MouseEvent.CLICK, eqFunc);
			mainMc.dot.buttonMode = true;
			mainMc.dot.addEventListener(MouseEvent.CLICK, dotFunc);
			mainMc.bc.buttonMode = true;
			mainMc.bc.addEventListener(MouseEvent.CLICK, clearcur);
			mainMc.bOn.buttonMode = true;
			mainMc.bOn.addEventListener(MouseEvent.CLICK, onFunc);
			mainMc.bOn.mouseEnabled = false;
			mainMc.bOn.gotoAndStop(2);
			mainMc.bOff.buttonMode = true;
			mainMc.bOff.addEventListener(MouseEvent.CLICK, offFunc);
			mainMc.hideMc.visible = false;
			mainMc.hideMc.buttonMode = true;
			mainMc.hideMc.addEventListener(MouseEvent.CLICK, hideFunc);
			mainMc.reset_btn.buttonMode = true;
			mainMc.reset_btn.addEventListener(MouseEvent.CLICK, resetFunc);
			mainMc.coverMc.visible = false;
			mainMc.textPadMc.visible = false;
			txtDragMc.addEventListener(MouseEvent.MOUSE_DOWN, onDrag);
			txtDragMc.addEventListener(MouseEvent.MOUSE_UP, onDrop);
			var myText = mainMc.textPadMc["myTxt"];
			myText.text = "";
			myText.addEventListener(Event.ENTER_FRAME, onChange);
			myText.addEventListener(Event.CHANGE, onInputChange);
			txtUpBtn.buttonMode = true;
			txtDownBtn.buttonMode = true;
			txtUpBtn.addEventListener(MouseEvent.CLICK, upMove);
			txtDownBtn.addEventListener(MouseEvent.CLICK, dwonMove);
			//var myText = mainMc.textPadMc["myTxt"];
			mainMc.stage.focus = myText;
			/*mainMc.pom.buttonMode = true;
			mainMc.pom.addEventListener(MouseEvent.CLICK, sign);
			mainMc.expo.buttonMode = true;
			mainMc.expo.addEventListener(MouseEvent.CLICK, exp);
			mainMc.bAc.buttonMode = true;
			mainMc.bAc.addEventListener(MouseEvent.CLICK, clearAll);
			mainMc.ypxBtn.buttonMode = true;
			mainMc.ypxBtn.addEventListener(MouseEvent.CLICK, ypxFunc);
			mainMc.factBtn.buttonMode = true;
			mainMc.factBtn.addEventListener(MouseEvent.CLICK, factFunc);
			mainMc.sqrtBtn.buttonMode = true;
			mainMc.sqrtBtn.addEventListener(MouseEvent.CLICK, sqrtFunc);
			mainMc.ooxBtn.buttonMode = true;
			mainMc.ooxBtn.addEventListener(MouseEvent.CLICK, ooxFunc);
			mainMc.swapBtn.buttonMode = true;
			mainMc.swapBtn.addEventListener(MouseEvent.CLICK, swapFunc);
			mainMc.sinBtn.buttonMode = true;
			mainMc.sinBtn.addEventListener(MouseEvent.CLICK, sinFunc);
			mainMc.cosBtn.buttonMode = true;
			mainMc.cosBtn.addEventListener(MouseEvent.CLICK, cosFunc);
			mainMc.tanBtn.buttonMode = true;
			mainMc.tanBtn.addEventListener(MouseEvent.CLICK, tanFunc);
			mainMc.powrtBtn.buttonMode = true;
			mainMc.powrtBtn.addEventListener(MouseEvent.CLICK, powrtFunc);
			mainMc.invBtn.buttonMode = true;
			mainMc.invBtn.addEventListener(MouseEvent.CLICK, invFunc);
			mainMc.piBtn.buttonMode = true;
			mainMc.piBtn.addEventListener(MouseEvent.CLICK, piFunc);
			mainMc.logBtn.buttonMode = true;
			mainMc.logBtn.addEventListener(MouseEvent.CLICK, logFunc);
			mainMc.lnBtn.buttonMode = true;
			mainMc.lnBtn.addEventListener(MouseEvent.CLICK, lnFunc);
			mainMc.log2Btn.buttonMode = true;
			mainMc.log2Btn.addEventListener(MouseEvent.CLICK, log2Func);
			mainMc.memBtn.buttonMode = true;
			mainMc.memBtn.addEventListener(MouseEvent.CLICK, memFunc);
			mainMc.mreBtn.buttonMode = true;
			mainMc.mreBtn.addEventListener(MouseEvent.CLICK, mreFunc);
			mainMc.clobraceBtn.buttonMode = true;
			mainMc.clobraceBtn.addEventListener(MouseEvent.CLICK, cbFunc);
			mainMc.opbraceBtn.buttonMode = true;
			mainMc.opbraceBtn.addEventListener(MouseEvent.CLICK, obFunc);
			mainMc.mplusBtn.buttonMode = true;
			mainMc.mplusBtn.addEventListener(MouseEvent.CLICK, mplusFunc);
			mainMc.mminusBtn.buttonMode = true;
			mainMc.mminusBtn.addEventListener(MouseEvent.CLICK, mminusFunc);*/
		}
		
		private function onDrag(evt:MouseEvent) {
			txtDragMc.startDrag(false, new Rectangle(txtDragMc.x, txtBarMc.y, 0, moveArea));
			txtDragMc.addEventListener(Event.ENTER_FRAME, onMove);
			txtDragMc.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDrop);
		}
		
		private function onMove(evt:Event) {
			var textScrollV = Math.ceil((txtDragMc.y-txtBarMc.y)/moveVal);
			var myText = mainMc.textPadMc["myTxt"];
			myText.scrollV=textScrollV;
			////trace("textScrollV = "+textScrollV);
		}
		
		private function onChange(evt:Event) {
			var myText = mainMc.textPadMc["myTxt"];
			moveVal=Math.round(moveArea/myText.maxScrollV);
			
			////trace("CHANGE");

		}
		
		private function onInputChange(evt:Event) {
			var myText = mainMc.textPadMc["myTxt"];
			userText = myText.text;
			mainMc.stage.focus = myText;
			//moveVal=Math.round(moveArea/myText.maxScrollV);
			////trace("CHANGE");

		}
		
		private function upMove(evt:MouseEvent) {
			var myText = mainMc.textPadMc["myTxt"];
			myText.scrollV=myText.scrollV-1;
			txtDragMc.y=txtDragMc.y-moveVal;
			(txtDragMc.y<txtBarMc.y)?(txtDragMc.y=txtBarMc.y):"";
			//txtDragMc.y = txtBarMc.y+(moveVal*(myTxt.scrollV-1));
		}
		
		private function dwonMove(evt:MouseEvent) {
			var myText = mainMc.textPadMc["myTxt"];
			myText.scrollV=myText.scrollV+1;
			txtDragMc.y=txtDragMc.y+moveVal;
			(txtDragMc.y>(txtBarMc.height-txtDragMc.height))?(txtDragMc.y=(txtBarMc.y+moveArea)):"";
			//txtDragMc.y = txtBarMc.y+Math.round(moveVal*(myTxt.scrollV));
		}
		
		private function onDrop(evt:MouseEvent) {
			txtDragMc.stopDrag();
			txtDragMc.removeEventListener(Event.ENTER_FRAME, onMove);
		}
		
		private function resetFunc(obj:MouseEvent) {
			dotFlg = false
			 cleard();
			 
			 for(var i=0; i<=9; i++){
				var numClip:MovieClip = mainMc["b"+i];
				numClip.mouseEnabled = true;
				numClip.gotoAndStop(1);
			}
			for(var j=1; j<=operArr.length; j++){
				var operClip:MovieClip = mainMc["opBtn"+j];
				operClip.mouseEnabled = true;
				operClip.gotoAndStop(1);
			}
			mainMc.equalBtn.mouseEnabled = true;
			mainMc.equalBtn.gotoAndStop(1);
			mainMc.dot.mouseEnabled = true;
			mainMc.dot.gotoAndStop(1);
			mainMc.bc.mouseEnabled = true;
			mainMc.bc.gotoAndStop(1);
			mainMc.bOn.gotoAndStop(2);
			mainMc.bOn.mouseEnabled = false;
			mainMc.bOff.mouseEnabled = true;
			mainMc.bOff.gotoAndStop(1);
			mainMc.coverMc.visible = false;
		}
		
		private function hideFunc(obj:MouseEvent){
			if(obj.currentTarget.currentFrame==1){
				mainMc.textPadMc.visible = false;
				obj.currentTarget.gotoAndStop(2);
			}else{
				mainMc.textPadMc.visible = true;
				obj.currentTarget.gotoAndStop(1);
			}
			var myText = mainMc.textPadMc["myTxt"];
			mainMc.stage.focus = myText;
		}
		
		private function onFunc(obj:MouseEvent) {
			cleard();
			for(var i=0; i<=9; i++){
				var numClip:MovieClip = mainMc["b"+i];
				numClip.mouseEnabled = true;
				numClip.gotoAndStop(1);
			}
			for(var j=1; j<=operArr.length; j++){
				var operClip:MovieClip = mainMc["opBtn"+j];
				operClip.mouseEnabled = true;
				operClip.gotoAndStop(1);
			}
			mainMc.equalBtn.mouseEnabled = true;
			mainMc.equalBtn.gotoAndStop(1);
			mainMc.dot.mouseEnabled = true;
			mainMc.dot.gotoAndStop(1);
			mainMc.bc.mouseEnabled = true;
			mainMc.bc.gotoAndStop(1);
			mainMc.bOn.gotoAndStop(2);
			mainMc.bOn.mouseEnabled = false;
			mainMc.bOff.mouseEnabled = true;
			mainMc.bOff.gotoAndStop(1);
			mainMc.coverMc.visible = false;
			obj.currentTarget.gotoAndPlay(3);
			var myText = mainMc.textPadMc["myTxt"];
			mainMc.stage.focus = myText;
		}
		
		private function offFunc(obj:MouseEvent){
			for(var i=0; i<=9; i++){
				var numClip:MovieClip = mainMc["b"+i];
				numClip.mouseEnabled = false;
				//numClip.gotoAndStop(2);
			}
			for(var j=1; j<=operArr.length; j++){
				var operClip:MovieClip = mainMc["opBtn"+j];
				operClip.mouseEnabled = false;
				//operClip.gotoAndStop(2);
			}
			mainMc.equalBtn.mouseEnabled = false;
			//mainMc.equalBtn.gotoAndStop(2);
			mainMc.dot.mouseEnabled = false;
			//mainMc.dot.gotoAndStop(2);
			
			mainMc.bc.mouseEnabled = false;
			//mainMc.bc.gotoAndStop(2);
			mainMc.bOn.gotoAndStop(1);
			mainMc.bOn.mouseEnabled = true;
			mainMc.bOff.mouseEnabled = false;
			mainMc.bOff.gotoAndStop(2);
			mainMc.coverMc.visible = true;
			cleard();
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function setTxt(obj:MouseEvent){
			digit(obj.currentTarget.num);
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function setOper(obj:MouseEvent){
			operator(obj.currentTarget.oper);
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function ypxFunc(obj:MouseEvent){
			operator("pow");
		}
		
		private function eqFunc(obj:MouseEvent){
			entered();
			//trace("digitEntered = "+digitEntered+" level ="+level+" userUnitTest = "+userUnitTest);
			if(digitEntered==0){
				if(userUnitTest!=""){
					//userText += dispValue;
					var myDispTxt = String(dispValue);
					myDispTxt = myDispTxt.slice(0, (myDispTxt.length-1));
					userText = userText+myDispTxt;
					userUnitTest = userUnitTest+myDispTxt;
					userTextArr[equationEntered] = userText;
					showText();
					////trace("read");
				}else{
					evalEmpText();
				}
			}
			digitEntered = 0;
			//trace("dispValue = "+dispValue);
	        while (level>0){
                evalx();
			}
			equalClicked = 1;
			equationEntered += 1;
			//trace("dispValue111 = "+dispValue);
	        showText();
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function evalEmpText(){
			var myDispTxt = String(dispValue);
			myDispTxt=myDispTxt.slice(0,myDispTxt.length-1);
			//trace("currSecVal = "+currSecVal);
			if(currOper=="+"){
				dispValue = Number(dispValue)+currSecVal;
			}else if(currOper=="-"){
				dispValue = Number(dispValue)-currSecVal;
			}else if(currOper=="*"){
				dispValue = Number(dispValue)*currSecVal;
			}else if(currOper=="/"){
				dispValue = Number(dispValue)/currSecVal;
			}
			myDispTxt = myDispTxt+currOper+currSecVal;
			userText = userText+myDispTxt;
			userUnitTest = userUnitTest+myDispTxt;
			userTextArr[equationEntered] = userText;
			showText();
		}
		var dotFlg:Boolean
		private function dotFunc(obj:MouseEvent){
			if (enteredVal){
                dispValue = 0;
                digits = 1;
	        }
	        enteredVal = false;
	        if (decimal == 0){
                decimal = 1;
	        }
			dotFlg=true
	        showText();
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function sign(obj:MouseEvent){
	        if (exponent){
                expval = -expval;
			} else{
                dispValue = -dispValue;
			}
        	showText();
		}
		
		private function exp(obj:MouseEvent){
	        if (enteredVal || exponent){
                return;
			}
        	exponent = true;
	        expval = 0;
	        digits = 0;
	        decimal = 0;
	        showText();
		}
		
		private function clearAll(obj:MouseEvent){
	        level = 0;
	        cleard();
		}
		
		private function factFunc(obj:MouseEvent){
	        func("fact");
		}
		
		private function swapFunc(obj:MouseEvent){
	        func("swap");
		}
		
		private function sqrtFunc(obj:MouseEvent){
	        func("sqrt");
		}
		
		private function invFunc(obj:MouseEvent){
       		inverse = !inverse;
		}
		
		private function sinFunc(obj:MouseEvent){
	        func("sin");
		}
		
		private function cosFunc(obj:MouseEvent){
	        func("cos");
		}
		
		private function tanFunc(obj:MouseEvent){
	        func("tan");
		}
		
		private function powrtFunc(obj:MouseEvent){
	        operator("powrt");
		}
		
		private function clearcur(obj:MouseEvent){
	        cleard();
			obj.currentTarget.gotoAndPlay(3);
		}
		
		private function ooxFunc(obj:MouseEvent){
	        func("1/x");
		}
		
		private function piFunc(obj:MouseEvent){
	        func("pi");
		}
		
		private function logFunc(obj:MouseEvent){
	        func("log");
		}
		
		private function obFunc(obj:MouseEvent){
	        entered();
            if (!push(0,'(',0))
            {
                    dispValue = "NAN";
            }
            showText();
		}
		
		private function cbFunc(obj:MouseEvent){
	        entered();
            while (evalx()){
            	showText();
			}
		}
		
		private function lnFunc(obj:MouseEvent){
	        func("ln");
		}
		
		private function log2Func(obj:MouseEvent){
	        func("log2");
		}
		
		private function memFunc(obj:MouseEvent){
	        func("Min");
		}
		
		private function mreFunc(obj:MouseEvent){
	        func("MR");
		}
		
		private function mplusFunc(obj:MouseEvent){
	        func("MPlus");
		}
		
		private function mminusFunc(obj:MouseEvent){
	        func("MMinus");
		}
		
		private function initArray(){
			for(var i=0; i<stackSize; i++){
				stack[i]= {val:0, op:"", prec:0};
			}
		}
		
		private function push(valu,op,prec){
	        if (level==stackSize){
                return false;
			}
       		for (var i=level;i>0; --i){
                stack[i].val = stack[i-1].val;
                stack[i].op = stack[i-1].op;
                stack[i].prec = stack[i-1].prec;
	        }
        	stack[0].val = valu;
        	stack[0].op = op;
        	stack[0].prec = prec;
        	++level;
        	return true;
		}
		
		private function pop(){
       		if (level==0){
                return false;
			}
        	for (var i=0;i<level; ++i){
                stack[i].val = stack[i+1].val;
                stack[i].op = stack[i+1].op;
                stack[i].prec = stack[i+1].prec;
        	}
        	--level;
       		return true;
		}
		
		private function format(valu){
			
        	var valStr = "" + valu;
			//trace("valu::::::::"+valStr.substring(0, 1));
			
        	if (valStr.indexOf("N")>=0 || (dispValue == 2*valu && dispValue == 1+valu)){
                return "Error ";
			}
       		var i = valStr.indexOf("e")
        	if (i>=0){
                var expStr = valStr.substring(i+1, valStr.length);
                if (i>11){
					i=11;
				}
                valStr = valStr.substring(0, i);
                if (valStr.indexOf(".")<0){
					valStr += ".";
				}
                //valStr += " " + expStr;
				valStr += "e" + expStr;
        	} else {
                var valNeg = false;
                if (valu < 0) { 
					dispValue = -valu; 
					valNeg = true; 
				}
                var valInt = Math.floor(dispValue);
                var valFrac = valu - valInt;
                var prec = totDigits - (""+valInt).length - 1;    
                if (!enteredVal && fixed>0){
                    prec = fixed;
				}
				////trace("prec = "+prec);
                var mult = " 1000000000000000000".substring(1,prec+2);
                var frac = Math.floor(valFrac * mult + 0.5);
				////trace("dispValue111 = "+dispValue);
				////trace("mult = "+mult);
                valInt = Math.floor(Math.floor(dispValue * Number(mult) + .5) / Number(mult));
				////trace("valInt = "+valInt);
                if (valNeg){
                    valStr = "-" + valInt;
				} else{
                    valStr = "" + valInt;
				}
				
                var fracStr = "00000000000000"+frac;
                fracStr = fracStr.substring(fracStr.length-prec, fracStr.length);
				//if(exponent){
					//i = fracStr.length-2;
				//}else {
                i = fracStr.length-1;
				//}
                if (enteredVal || fixed==0){
                    while (i>=0 && fracStr.charAt(i)=="0"){
                        --i;
					}
                    fracStr = fracStr.substring(0,i+1);
                }
                if (i>=0){
					valStr += "." + fracStr;
				}
				if(prec<0){
					//valStr = 
					valStr = "" + valu;
					////trace("ganesh valu = "+valu);
					return valStr;
				}
        	}
			////trace("ganeshhhh");
			if(valStr.substring(0, 1) == "-"){
				 valStr ="Error"
			}
        	return valStr;
		}
		
		private function showText(){
        	var display = format(dispValue);
			////trace("displaygggg = "+display);
			if (display.indexOf(".")<0 && display != "Error "){
				////trace("displaygggg1111 = "+display);
				
                if (enteredVal || decimal > 0) {
					//display += '.'
					if (dotFlg)
					{
                    display += '.';
					dotFlg =false
					}
					/*if(display == "0."){
						userText = userText+"0.";
						userTextArr[equationEntered] = userText;
					}*/
					
				} else{
					////trace("displaygggg2222 = "+display);
                    display += ' ';
        		}
				trace(decimal)
				if(decimal>0){
					if(display == "0."){
						userText = userText+"0.";
						userTextArr[equationEntered] = userText;
					}else{
						userText = userText + ".";
						//userText = userText
						userTextArr[equationEntered] = userText;
					}
					////trace("GANESH");
				}
			}
			////trace("displaygggg = "+display);
			dispValue = display;
			////trace("display = "+display);
			if (exponent){
                if (expval<0){
                    display += " " + expval;
				} else{
                    display += " +" + expval;
        		}
			}
        	display = "" + display;
			//trace("display = "+display);
        	display = display.substring(display.length-totDigits-1,display.length);
        	my_txt.text = display;
			
        	inverse = false;
			showUserText();
		}
		
		private function showUserText(){
			var myText = mainMc.textPadMc["myTxt"];
			//myText.text = "";
			if(equalClicked == 1){
				equalClicked = 0;
				userText = userText+"="+dispValue;
				userText += "\n";
				myText.text += "="+dispValue;
				myText.text += "\n";
				userUnitTest = "";
				////trace("first");
			}else{
				////trace("second");
				myText.text = userText;
			}
			mainMc.stage.focus = myText;
		}
		
		private function showUserText1(){
			var myText = mainMc.textPadMc["myTxt"];
			myText.text = "";
			if(equalClicked == 1){
				equalClicked = 0;
				userText = userText+"="+dispValue;
				userTextArr[equationEntered-1] = userText;
				userText = "";
				//myText.text = userText;
				
			}
			////trace("userTextArr = "+userTextArr);
			for(var i=0; i<userTextArr.length; i++){
				myText.text = myText.text+userTextArr[i];
				myText.text = myText.text+"\n";
			}
			/*var myText = mainMc.textPadMc["myTxt"];
			myText.text = userText;
			if(equalClicked == 1){
				equalClicked = 0;
				userText = userText+"="+dispValue;
				myText.text = userText;
				myText.text = myText.text+"\n";
				myText.text = myText.text+"the";
			}*/
		}
		
		private function cleard(){
	        exponent = false;
			stack = []
			userTextArr = []
			        
		initArray()         
		enteredVal = true;    
		decimal = 0;               
		fixed = 0;          
		exponent = false;
		expval = 0;
		prec = 0;
		inverse = false;    
		memory=null
		digits=null
		digitEntered = 0;
		equalClicked = 0;
		 equationEntered = 0;
		moveVal=1;
		moveArea = 0;
		currOper="";
		currSecVal=0;
        	dispValue = 0;
        	entered();
			var myText = mainMc.textPadMc["myTxt"];
			myText.text = "";
			equalClicked = 0;
			equationEntered = 0;
			userTextArr = [];
			userText = "";
				
			
        	showText();
		}
		
		private function evalx(){
	        if (level==0){
                return false;
			}
        	var op = stack[0].op;
        	var sval = stack[0].val;
	        if (op == '+'){
				currSecVal=Number(dispValue);
				dispValue = Number(sval) + Number(dispValue);
				currOper="+";
				
			} else if (op == '-'){
				currSecVal=Number(dispValue);
                dispValue = sval - dispValue;
				currOper="-";
			} else if (op == '*'){
				currSecVal=Number(dispValue);
                dispValue = sval * dispValue;
				currOper="*";
			} else if (op == '/'){
				currSecVal=Number(dispValue);
                dispValue = sval / dispValue;
				currOper="/";
			} else if (op == 'pow'){
                dispValue = Math.pow(sval, dispValue);
			} else if (op == 'powrt'){
                dispValue = Math.pow(sval, (1/dispValue));
			}
			////trace("dispValue = "+dispValue);
			//trace("currSecVal GGGG = "+currSecVal);
        	pop();
        	if (op=='('){
                return false;
			}
        	return true;
		}
		
		private function operator(op){
        	entered();
			//pop();
			
        	if (op=='+' || op=='-'){
                prec = 1;
			} else if (op=='*' || op=='/'){
                prec = 2;
			} else if (op=="pow"){
                prec = 3;
			} else if (op=="powrt"){
                prec = 4;
			} 
			if(digitEntered == 1){
				digitEntered = 0;
				/*if (level>0 && prec <= stack[0].prec){
                	evalx();
				}*/
				while (level>0){
               		 evalx();
				}
	       		showText();
				
			}else{
				if(userUnitTest==""){
					var myVal = String(dispValue);
					////trace("dispValue = "+myVal+" ---  "+myVal.length+" --- "+myVal.substring(myVal.length+1, 1));
					//if(dispValue.substring(dispValue.length, 1) == ""
					var preVal = "";
					if(myVal.substr(myVal.length-1, 1)=="."){
						preVal = myVal.substr(0, (myVal.length-1));
					}else{
						preVal = myVal;
					}
					userText = userText+preVal;
					userUnitTest = userUnitTest+preVal;
					////trace("muText = "+dispValue);
				}else{
					userText = userText.slice(0, (userText.length-1));
				}
				
				////trace("userText = "+userText);
				pop();
				
			}
			
			if (level>0 && prec <= stack[0].prec){
                evalx();
				/*var sval = stack[0].val;
				userText = userText+sval;*/
				
			}
			
       		if (!push(dispValue,op,prec)){
                dispValue = "NAN";
        	}
			if(digitEntered == 1){
				addUserText();
			}else{
				
				addUserText();
			}
        	showText();
		}
		
		private function addUserText(){
			var op = stack[0].op;
			if(op=='+'){
				userText = userText+"+";
			}else if(op=='-'){
				userText = userText+"-";
			}else if(op=='*'){
				userText = userText+"*";
			}else if(op=='/'){
				userText = userText+"/";
			}
			userTextArr[equationEntered] = userText;
		}
		
		private function entered(){
	        if (exponent){
                dispValue = dispValue * Math.exp(expval * Math.LN10);
			}
        	enteredVal = true;
        	exponent = false;
        	decimal = 0;
        	fixed = 0;
		}
		
		private function digit(n){
        	if (enteredVal){
                dispValue = 0;
                digits = 0;
                enteredVal = false;
       		}
        	if (n==0 && digits==0){
                showText();
                return;
        	}
	        if (exponent){
                if (expval<0){
                    n = -n;
				}
                if (digits < 3){
                    expval = expval * 10 + n;
                    ++digits;
                    showText();
                }
                return;
        	}
        	if (dispValue<0){
                n = -n;
			}
        	if (digits < totDigits-1){
                ++digits;
                if (decimal>0){
                    decimal = decimal * 10;
                    dispValue = Number(dispValue) + (n/decimal);
                    ++fixed;
                }else{
                    dispValue = Number(dispValue) * 10 + n;
				}
        	}
			digitEntered = 1;
			userText = userText+n;
			userUnitTest = userUnitTest+n;
			userTextArr[equationEntered] = userText;
        	showText();
			
		}
		
		private function func(f){
        	entered();
        	if (f=="1/x"){
                dispValue = 1/dispValue;
			} else if (f=="swap"){
                var tmp = dispValue;
                dispValue = stack[0].val;
                stack[0].val = tmp;
	        } else if (f=='fact'){
                if (dispValue<0 || dispValue>200 || dispValue != Math.round(dispValue)){
                    dispValue = "NAN";
				} else{
                    var n = 1;
                    var i;
                    for (i=1;i<=dispValue;++i){
                       n *= i;
					}
                    dispValue = n;
                }
	        } else if (f=="MR"){
				if(memory != undefined){
                	dispValue = memory;
				}
			} else if (f=="Min"){
                memory = Number(dispValue);
        	} else if (f=="MPlus"){
				if(memory != undefined){
                	memory += Number(dispValue);
				}
            } else if (f=="MMinus"){
				if(memory != undefined){
					memory -= Number(dispValue);
				}
			} else if (inverse){
                if (f=="sin"){
                    dispValue = Math.asin(dispValue)*180/Math.PI;
				}else if (f=="cos"){
                    dispValue = Math.acos(dispValue)*180/Math.PI;
				}else if (f=="tan"){
                    dispValue = Math.atan(dispValue)*180/Math.PI;
				}else if (f=="log"){
                    dispValue = Math.exp(dispValue * Math.LN10);
				}else if (f=="log2"){
                    dispValue = Math.exp(dispValue * Math.LN2);
				}else if (f=="ln"){
                    dispValue = Math.exp(dispValue);
				}else if (f=="sqrt"){
                    dispValue = dispValue*dispValue;
				}else if (f=="pi"){
                    dispValue = Math.E;
				}
        	} else {
                if (f=="sin"){
                    dispValue = Math.sin(dispValue/180 * Math.PI);
				}else if (f=="cos"){
                    dispValue = Math.cos(dispValue/180 * Math.PI);
				}else if (f=="tan"){
                    dispValue = Math.tan(dispValue/180 * Math.PI);
				}else if (f=="log"){
                    dispValue = Math.log(dispValue)/Math.LN10;
				}else if (f=="log2"){
                    dispValue = Math.log(dispValue)/Math.LN2;
				}else if (f=="ln"){
                    dispValue = Math.log(dispValue);
				}else if (f=="sqrt"){
                    dispValue = Math.sqrt(dispValue);
				}else if (f=="pi"){
                    dispValue = Math.PI;
				}
        	}
        	showText();
		}
	}
}