﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.display.Loader;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class Toys extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var LoaderMC:preloader_mc=new preloader_mc();
		private var TotalImages:Number=0;
		private var LoadedImageCount:Number=0;
		private var ImagesArray:Array=new Array();
		private var RowsCount:Number=0;
		private var ColsCount:Number=0;
		private var randomNum:int;
		
		private var sw:Number=760;
		private var sh:Number=530;
		
		private var Btn10:counter=new counter();
		private var Btn20:counter2=new counter2();
		private var shT:shtotal=new shtotal();
		private var hT:htotal=new htotal();
		private var newSetBtn:newSet_btn = new newSet_btn();
		private var TotalText:TotalTxt=new TotalTxt();
		private var Current_No_Images:int=0;
		private var SelectedMC:MovieClip;
		private var shuffledArray:Array = new Array();
		private var startInd:Number = 1;
		private var endInd:Number = 10;
		
		public function Toys()
		{			
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO1_50.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));		
			FindTotalImages();			
			CreateToys();
						
		}		
		private function FindTotalImages():void
		{
			var Rows:Number=XMLObj.Toys.Toy.length();
			for(var i:int=0;i<Rows;i++)
			{
				var Cols:Number=XMLObj.Toys.Toy[i].Image.length();
				TotalImages+=Cols;
			}
		}
		private function LoadImages():void
		{
			if(LoadedImageCount<TotalImages)
			{
				var ImPath:String=XMLObj.Toys.Toy[RowsCount].Image[ColsCount].@url;		
			
				LoadImage(ImPath);
			}
			if(LoadedImageCount==TotalImages)
			{
				AddButtons();
				AddTotalText();	
				showRandomImages();
				removeChild(LoaderMC);
			}
		}
		private function ShowRandom(minNum:Number,maxNum:Number):int
		{
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);
		}
		
		private function fnShuffleArray():Array{			
			var shuffledLetters:Array = new Array(ImagesArray.length); 
			var emptySlots:Array = new Array();
			for (var n:int = 0; n < ImagesArray.length; n++){    
				emptySlots.push(n);
			} 
			var randomPos:Number = 0;
			var actualSlot:Number = 0;
			for (var i:int = 0; i < ImagesArray.length; i++){    
				randomPos = int(Math.random() * emptySlots.length); 
				actualSlot = emptySlots[randomPos];    
				shuffledLetters[actualSlot] = i;    
				emptySlots.splice(randomPos, 1);
			}
			return shuffledLetters;
		}
		
		private function showRandomImages():void
		{
			randomNum=ShowRandom(1,10);
			Current_No_Images=randomNum;
			shuffledArray = fnShuffleArray();
			for(var i:int=0;i<randomNum;i++)
			{
				ImagesArray[shuffledArray[i]].visible=true;
			}
		}
		private function LoadImage(path:String):void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(path));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,onImageLoaded);
		}
		private function onImageLoaded(e:Event):void
		{
			var tar:Loader=e.target.loader;
			var clip:MovieClip=new MovieClip();
			var mc=tar.content;
			clip.addChild(mc);
			addChild(clip);
			
			ImagesArray.push(clip);
			clip.visible=false;			
			
			clip.doubleClickEnabled=true;
			clip.mouseChildren=false;
			clip.buttonMode=true;
			clip.addEventListener(MouseEvent.DOUBLE_CLICK,HideIt);
			clip.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			
			clip.x=XMLObj.Toys.Toy[RowsCount].Image[ColsCount].@xpos;
			clip.y=XMLObj.Toys.Toy[RowsCount].Image[ColsCount].@ypos;	
			
			if(ColsCount==(XMLObj.Toys.Toy[RowsCount].Image.length()-1))
			{
				RowsCount++;
				ColsCount=0;
			}else
			{
				ColsCount++;
			}
			LoadedImageCount++;
			
			setChildIndex(LoaderMC,numChildren-1);
			
			var percentage:int = int((LoadedImageCount/TotalImages)*100);
			if ( percentage < 100 ) {
				LoaderMC.gotoAndStop(percentage);
				LoaderMC.txt.text = "loading..."+percentage+"%";
			} 
			
			LoadImages();
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			SelectedMC=tar;
			tar.startDrag(false,new Rectangle(0,0,720-tar.width,430-tar.height));
			setChildIndex(tar,numChildren-1);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			tar.addEventListener(MouseEvent.MOUSE_UP,DropIt);
		}
		private function DropIt(e:MouseEvent):void
		{			
			if(SelectedMC)
			{
				SelectedMC.stopDrag();
				SelectedMC.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);				
			}
		}
		private function CreateToys():void
		{
			
			addChild(LoaderMC);
			LoaderMC.x=(sw)/2;
			LoaderMC.y=(sh)/2;
			
			LoadImages();
		}
		private function AddButtons():void
		{
			addChild(Btn10);
			addChild(Btn20);
			addChild(newSetBtn);
			Btn10.gotoAndStop(3);
			Btn20.gotoAndStop(1);
			
			Btn10.buttonMode=true;
			Btn10.mouseChildren=false;
			Btn20.buttonMode=true;
			Btn20.mouseChildren=false;
			
			Btn10.x=XMLObj.Btn10.@xpos;
			Btn10.y=XMLObj.Btn10.@ypos;
			Btn20.x=XMLObj.Btn20.@xpos;
			Btn20.y=XMLObj.Btn20.@ypos;
			newSetBtn.x=XMLObj.newSet.@xpos;
			newSetBtn.y=XMLObj.newSet.@ypos;
			
			Btn10.addEventListener(MouseEvent.CLICK,show1to10RmadomImages);
			Btn20.addEventListener(MouseEvent.CLICK,show10to20RmadomImages);
			
			addChild(shT);
			addChild(hT);
			
			hT.visible=false;
			shT.buttonMode=true;
			hT.buttonMode=true;
			
			
			shT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			shT.addEventListener(MouseEvent.MOUSE_OUT,outState);
			hT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			hT.addEventListener(MouseEvent.MOUSE_OUT,outState);
			shT.addEventListener(MouseEvent.CLICK,showTotal);
			hT.addEventListener(MouseEvent.CLICK,hideTotal);
			newSetBtn.addEventListener(MouseEvent.CLICK,fnGenerateNewSet);
			
			shT.x=hT.x=XMLObj.ShowHideBtn.@xpos;
			shT.y=hT.y=XMLObj.ShowHideBtn.@ypos;			
		}
		private function show1to10RmadomImages(e:MouseEvent=null):void
		{
			Btn10.gotoAndStop(3);
			Btn20.gotoAndStop(1);
			startInd = 1;
			endInd = 10;
		}
		private function show10to20RmadomImages(e:MouseEvent):void
		{
			Btn10.gotoAndStop(1);
			Btn20.gotoAndStop(3);
			startInd = 10;
			endInd = 20;
		}
		
		private function fnGenerateNewSet(eve:MouseEvent = null):void{
			for(var i:int=0;i<ImagesArray.length;i++)
			{
				ImagesArray[i].visible=false;
			}
			randomNum=ShowRandom(startInd,endInd);
			shuffledArray = fnShuffleArray();
			for(i=0;i<randomNum;i++)
			{
				ImagesArray[shuffledArray[i]].visible=true;
			}
			TotalText.txt.text=""+randomNum;
			Current_No_Images=randomNum;
			
		}
		private function AddTotalText():void
		{
			addChild(TotalText);
			TotalText.x=XMLObj.TotalText.@xpos;
			TotalText.y=XMLObj.TotalText.@ypos;
			TotalText.txt.text="0";
			TotalText.visible=false;
		}
		private function showTotal(e:MouseEvent):void
		{
			shT.visible=false;
			hT.visible=true;
			TotalText.visible=true;
			TotalText.txt.text=""+Current_No_Images;
		}
		private function hideTotal(e:MouseEvent):void
		{
			shT.visible=true;
			hT.visible=false;
			TotalText.visible=false;
		}
		private function overState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOver(Tar);
		}
		private function outState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOut(Tar);
		}
		private function showOver(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(2);
			}
		}
		private function showOut(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(1);
			}
		}
		private function HideIt(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			Tar.visible=false;			
			Current_No_Images--;
			TotalText.txt.text=""+Current_No_Images;
		}
		public function onReset(e:MouseEvent):void
		{
			Btn10.gotoAndStop(3);
			Btn20.gotoAndStop(1);
			try
			{
				startInd = 1;
				endInd = 10;
				fnGenerateNewSet();
			}catch(e:Error)
			{
				
			}
			
		}
	}
}